---
title: DOMPointReadOnly
slug: Web/API/DOMPointReadOnly
tags:
  - API
  - Coordinate
  - DOM
  - DOM Reference
  - DOMPointReadOnly
  - Geometry
  - Geometry Interfaces
  - Interface
  - Point
  - Reference
---
<div>{{APIRef("Geometry Interfaces")}}</div>

<p><span class="seoSummary">The <strong><code>DOMPointReadOnly</code></strong> interface specifies the coordinate and perspective fields used by {{domxref("DOMPoint")}} to define a 2D or 3D point in a coordinate system.</span></p>

<p>{{AvailableInWorkers}}</p>

<p>There are two ways to create a new <code>DOMPointReadOnly</code> instance. First, you can use its constructor, passing in the values of the parameters for each dimension and, optionally, the perspective:</p>

<pre class="brush: js">/* 2D */
const point = new DOMPointReadOnly(50, 50);

/* 3D */
const point = new DOMPointReadOnly(50, 50, 25);

/* 3D with perspective */
const point = new DOMPointReadOnly(100, 100, 100, 1.0);</pre>

<p>The other option is to use the static {{domxref("DOMPointReadOnly.fromPoint()")}} method:</p>

<pre class="brush: js">const point = DOMPointReadOnly.fromPoint({x: 100, y: 100, z: 50; w: 1.0});</pre>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("DOMPointReadOnly.DOMPointReadOnly","DOMPointReadOnly()")}}</dt>
 <dd>Creates a new <code>DOMPointReadOnly</code> object given the values of its coordinates and perspective. To create a point using a<code>DOMPointInit</code> object, you can instead use {{domxref("DOMPointReadOnly.fromPoint()")}}.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("DOMPointReadOnly.x")}} {{readonlyInline}}</dt>
 <dd>The point's horizontal coordinate, <code>x</code>.</dd>
 <dt>{{domxref("DOMPointReadOnly.y")}} {{readonlyInline}}</dt>
 <dd>The point's vertical coordinate, <code>y</code>.</dd>
 <dt>{{domxref("DOMPointReadOnly.z")}} {{readonlyInline}}</dt>
 <dd>The point's depth coordinate, <code>z</code>.</dd>
 <dt>{{domxref("DOMPointReadOnly.w")}} {{readonlyInline}}</dt>
 <dd>The point's perspective value, <code>w</code>.</dd>
</dl>

<h2 id="Static_methods">Static methods</h2>

<dl>
 <dt>{{domxref("DOMPointReadOnly.fromPoint()")}}</dt>
 <dd>A static method that creates a new <code>DOMPointReadOnly</code> object given the coordinates provided in the specified {{domxref("DOMPointInit")}} object.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("DOMPointReadOnly.matrixTransform", "matrixTransform()")}}</dt>
 <dd>Applies a matrix transform specified as a {{domxref("DOMMatrixInit")}} object to the <code>DOMPointReadOnly</code> object.</dd>
 <dt>{{domxref("DOMPointReadOnly.toJSON()", "toJSON()")}}</dt>
 <dd>Returns a JSON representation of the <code>DOMPointReadOnly</code> object.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('Geometry Interfaces', '#DOMPoint', 'DOMPoint')}}</td>
   <td>{{Spec2('Geometry Interfaces')}}</td>
   <td>Latest spec version is an ED.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DOMPointReadOnly")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("DOMPoint")}}</li>
 <li>{{domxref("DOMRect")}}</li>
 <li>{{domxref("DOMMatrix")}}</li>
</ul>
